<?php
// Most of the code here is borrowed from
// **************************************
// Author: Beaker <kuren at kuren dot org>
// Site: http://tera.kuren.org/basicbot
// Discussion:  the forums at http://www.hackersquest.org/boards/viewforum.php?f=7

global $SendReply;
global $minimum_delay;
$minimum_delay = 0.500; #seconds ;)
/******
******* do a reply ;)
******/
function send_reply($msg,$blob="\0")
{
	global $SendReply;
	if (!is_array($SendReply))
    return false;
	elseif ($SendReply["type"]==30)
		send_private_tell($SendReply["name"],$msg,$blob);
	elseif ($SendReply["type"]==65)
		send_public_channel_message($SendReply["name"],$msg,$blob);
	elseif ($SendReply["type"]==57)
		say("SendReply :: Got a private channel message?!",1);
}

/******
******* queue a /tell 
******/
function send_private_tell($user,$msg,$blob="\0")
{
	global $queue;
	if (strlen($user)>3 && strlen($msg)>0)
	{
		$message_to_put_on_queue["type"]   ="tell";
		$message_to_put_on_queue["who"]    ="$user";
		$message_to_put_on_queue["message"]=german_vowels_out("$msg");
		$message_to_put_on_queue["blob"]   ="$blob";
		$queue[]=$message_to_put_on_queue;
	}
}
/****** 
******* queue a public channel message
******/
function send_public_channel_message($channel_name,$msg,$blob="\0") {
	global $queue;
	if (strlen($channel_name)>0 && strlen($msg)>0)
	{
		$message_to_put_on_queue["type"]        ="public channel message";
		$message_to_put_on_queue["channel name"]="$channel_name";
		$message_to_put_on_queue["message"]     =german_vowels_out("$msg");
		$message_to_put_on_queue["blob"]        ="$blob";
		$queue[]=$message_to_put_on_queue;
	}
}
/****** 
******* queue a guild channel message
******/
function send_guild_channel_message($msg,$blob="\0") {
	global $myguild;
	if ($myguild) send_public_channel_message($myguild,$msg,$blob="\0");
	else say("Cannot send to guild $myguild..",1);
}
/******
******* queue a private channel message 
******/
function send_private_channel_message($channel_name,$msg,$blob="\0") {
	global $queue;
	if (strlen($channel_name)>3 && strlen($msg)>0)
	{
		$message_to_put_on_queue["type"]        ="private channel message";
		$message_to_put_on_queue["channel name"]="$channel_name";
		$message_to_put_on_queue["message"]     =german_vowels_out("$msg");
		$message_to_put_on_queue["blob"]        ="$blob";
		$queue[]=$message_to_put_on_queue;
	}
}
/****** outgoing chat:
******* translate german vowels
******/
function german_vowels_out($txt) {
  return strtr(utf8_encode($txt),array("" => "__","" => "___","" => "___","" => "_","" => "_","" => "_","" => "_"));
}
/****** Process queue
******* _o_o_o_o_o_o_o_o_________________
******/
function process_queue() {
	global 	
		$AOC,
		$queue,
		$time_of_last_tell,
		$myname,
		$minimum_delay;

	// how long has it been since the last /tell was sent out?
	$delay=getmicrotime()-$time_of_last_tell;
	
	$x=false; $i=0;
	foreach ($queue as $i=>$message) {
		if ($message["when"]<getmicrotime()) {
			if     ($delay>$minimum_delay && $message["type"]=="public channel message") 
			{
				array_splice($queue,$i,1);
				$time_of_last_tell = getmicrotime();
				$AOC->send_group($message["channel name"],$message["message"],$message["blob"]);
				break;
			}
			elseif ($delay>$minimum_delay && $message["type"]=="private channel message") 
			{
				array_splice($queue,$i,1);
				$time_of_last_tell = getmicrotime();
				$AOC->send_privgroup($message["channel name"],$message["message"],$message["blob"]);
				break;
			}
			elseif ($delay>$minimum_delay && $message["type"]=="tell") 
			{
				array_splice($queue,$i,1);
				$time_of_last_tell = getmicrotime();
				$AOC->send_tell($message["who"], $message["message"], $message["blob"]);
				say("[Queue] ".$message["who"].": ".stripcolors($message["message"])."\n",1);
				break;
			}
			elseif ($message["type"]=="addbuddy")
			{
				array_splice($queue,$i,1);
				$name=ucfirst(ereg_replace('[^a-z0-9]',"",strtolower($message["name"])));
				if (strlen($name)>0 && 	$name!=$myname)	
				{
					$AOC->buddy_add($name);
					break;
				}
			}
			elseif ($message["type"]=="rembuddy")
			{
				array_splice($queue,$i,1);
				$name=ucfirst(ereg_replace('[^a-z0-9]',"",strtolower($message["name"])));
				if (strlen($name)>0 && 	$name!=$myname)
				{
					$AOC->buddy_add($name);
					break;
				}
			}
		}
	}
}
/******
******* this function is used to prevent chat flood, by making a timestamp, in seconds
******/
function getmicrotime()
{
	list($usec, $sec) = explode(" ",microtime());
	return ((float)$usec + (float)$sec);
}


?>